function init()

    UFO = FindBody("saucer")
    SetBodyDynamic(UFO, false)
    
    UFOGuns = FindLocations("shoot")
    UFOGunTimerDefault = GetFloat('level.fire_rateN') or 2
    print('spawned: fire rate: ' .. GetFloat('level.fire_rateN'))
    UFOGunPower = 0.5
    UFOGunMaxDistance = 50
    UFOGunStartShootingAtDistance = 30
    UFOGunActive = true
    UFOGunType = "bullet" -- or "rocket", "gun", "bullet", "shotgut"
    
    UFOGunLocationOffsets = {}
    for i=1,#UFOGuns do
      local ufot = GetBodyTransform(UFO)
      local gunt = GetLocationTransform(UFOGuns[i])
      local offset = TransformToLocalTransform(ufot,gunt)
      table.insert(UFOGunLocationOffsets,{offset=offset,timer=UFOGunTimerDefault+math.random()*3})
    end
    
    local destroyCount = GetInt('level.destroy_count') or 0
    
    UFOSpeed = 0.0025 + (destroyCount/1000) -- this is the speed the ufo will move towards the player every tick (multiple times during a second)
    print('UFOSpeed',UFOSpeed)
    MetersAbovePlayer = 12.0

    Hum = LoadLoop("MOD/Saucer/snd/UFO_Hum.ogg")
    Blips = LoadLoop("MOD/Saucer/snd/UFO_Blips.ogg")
    Break = LoadSound("MOD/Saucer/snd/UFO_Break.ogg")
    Start = LoadSound("MOD/Saucer/snd/UFO_Start.ogg")
    Shot = LoadSound("MOD/Saucer/snd/UFO_Shoot.ogg")

    destroySoundPlayed = false

    LightShapes = FindShapes("saucer_light")

    UFOvox = FindShape("saucer_vox")
    UFOVoxelCount = getUfoVoxelCount()
    UFODamagedThreshhold = 2000

    UFOBroken = false
    
    explodeTimer = 0
    explodeAfter = 4

end

function shootTimer(dt)
  for i=1,#UFOGunLocationOffsets do
    local ufot = GetBodyTransform(UFO)
    local gun = UFOGunLocationOffsets[i]
    local gunt = gun.offset
    local t = TransformToParentTransform(ufot,gunt)
    -- DebugLine(t.pos,ufot.pos,1,0,0)
    -- DebugCross(t.pos,1,1,0)
    if gun.timer < 0 then
      local pt = GetPlayerTransform()
      pt.pos = VecAdd(pt.pos,Vec(0,1,0))
      local dist = VecLength(VecSub(t.pos,pt.pos))
      -- print(dist)
      if dist < UFOGunStartShootingAtDistance then
        local dir = VecNormalize(VecSub(pt.pos,t.pos))
        local hit, dist, normal, shape = QueryRaycast(t.pos, dir, dist)
        if not hit or (hit and not isShapeInBody(shape,UFO)) then
          Shoot(t.pos,dir,UFOGunType,UFOGunPower,UFOGunMaxDistance)
          PlaySound(Shot, t.pos, 4)
        end
      end
      gun.timer = UFOGunTimerDefault
    else
      gun.timer = gun.timer - dt
    end
  end
end

function isShapeInBody(shape,body)
  local shapes = GetBodyShapes(body)
  for i=1,#shapes do
    if shapes[i] == shape then
      return true
    end
  end
  return false
end


function tick(dt)

    -- DebugWatch("Damage", UFOVoxelCount - getUfoVoxelCount())

    if not UFOBroken then
        local UFOt = GetBodyTransform(UFO)
        if getUfoVoxelCount() < (UFOVoxelCount - UFODamagedThreshhold) or allLightsBroken() then
            UFOBroken = true
            SetBodyDynamic(UFO, true)
            ApplyBodyImpulse(UFO, VecAdd(UFOt.pos,Vec(0,0,0)))
            SetBodyAngularVelocity(UFO,Vec(math.random(-5,5),0,math.random(-5,5)))
            PlaySound(Break, UFOt.pos, 2)
            local destroyCount = GetInt('level.destroy_count') or 0
            SetInt('level.destroy_count', destroyCount + 1)
        else
            local targetPos = VecSub(GetPlayerTransform().pos, Vec(0, - MetersAbovePlayer, 0))
            local UFOpos = VecLerp(UFOt.pos, targetPos, UFOSpeed)
            local UFOspin = QuatRotateQuat(UFOt.rot, QuatEuler(0, 2, 0))
            PlayLoop(Hum, UFOpos, 2)
            PlayLoop(Blips, UFOpos, 2)
            SetBodyDynamic(UFO, false)
            SetBodyTransform(UFO, Transform(UFOpos, UFOspin))
            if UFOGunActive then
              shootTimer(dt)
            end
        end
    end
    
    if UFOBroken and explodeTimer < explodeAfter then 
      explodeTimer = explodeTimer + dt
      if explodeTimer > explodeAfter then
        local UFOt = GetBodyTransform(UFO)
        Explosion(UFOt.pos,3)
        SetTag(UFO,"destroyed")
      end
    end
    
    
    -- local hit, d = QueryRaycast(UFOpos, Vec(0, - 1, 0), 10)
    -- if hit then
    --     -- DebugPrint("Hit")
    -- else
    --     -- DebugPrint("No Hit")
    -- end
end

function allLightsBroken()
    for i = 1, #LightShapes do
        local lightShape = LightShapes[i]
        if not IsShapeBroken(lightShape) then
            return false
        end
    end
    return true
end

function getUfoVoxelCount()
    local count = 0
    count = count + GetShapeVoxelCount(UFOvox)
    for i = 1, #LightShapes do
        local lightShape = LightShapes[i]
        count = count + GetShapeVoxelCount(lightShape)
    end
    return count
end












-- something i played with .. ignore

-- UFOLightShapes = FindShapes("saucer_light")
-- lights = {}
-- for i=1,#UFOLightShapes do
--   local s = UFOLightShapes[i]
--   local on = i % 2
--   local up = on == 0 and true or false
--   SetShapeEmissiveScale(s,0.5)
--   table.insert(lights,{shape=s,scale=on/2,up=up})
-- end
--
-- function cycleLightScale()
--   local lightSpeed = 0.01
--   local lightMax = 0.5
--   for i=1,#lights do
--     local l = lights[i]
--     if l.up then
--       l.scale = l.scale + lightSpeed
--     else
--       l.scale = l.scale - lightSpeed
--     end
--
--     if l.scale >= lightMax then
--       l.up = false
--     end
--     if l.scale < 0 then
--       l.up = true
--     end
--     SetShapeEmissiveScale(l.shape,l.scale)
--   end
-- end
